function data = loadfast(pb,name,nt,st)
  
% load data
  
  eval(['data = pb.',name,';'])
  
  if isempty(data)
    disp('field not defined')
    return
  end
    
  % read base time vector
  
  [f  m ] = fopen([pb.f00,'_',data.name,'.t' ],'rb',pb.endian);
  if f==-1
    %if ~isempty(m);disp(m);return,end
    nt = 1;
  else
    if nargin>=3
      eval(['t  = fread(f ,[1 nt],',pb.pre,');']);
    else
      eval(['t  = fread(f ,[1 inf],',pb.pre,');']);
      nt = length(t);
    end
    fclose(f);
    
    disp(['Total time steps = ',num2str(nt)])
    data.t = t;
    data.nt = nt;
    data.tmin = min(data.t);
    data.tmax = max(data.t);
    
  end
  
  % set dimensions
  
  dim = 2;
  if data.nx==1;dim=dim-1;end
  if data.ny==1;dim=dim-1;end

  % open file
  
  [f m] = fopen([pb.f00,'_',data.name,'.dat'],'rb',pb.endian);
  if ~isempty(m);disp(m);end
  if f==-1;return;end
  
  % read data
  
  switch dim
      
    case 0
      
      readdata = ['data.',data.field,' = fread(f,[1 nt],',pb.pre,');'];
      
    case 1
      
      if data.nx~=1
          readdata = ['data.',data.field,' = fread(f,[data.nx nt],',pb.pre,');'];
      elseif data.ny~=1
          readdata = ['data.',data.field,' = fread(f,[data.ny nt],',pb.pre,');'];
      end
      
    case 2
      
      if data.field=='F'
          switch pb.mode
            case 2
              nF = 6;
            case 3
              nF = 3;
          end
          eval(['data.',data.field,' = zeros(data.nx,data.ny,nF,nt);']);
          readdata = ['data.',data.field,'(:,:,l,n) = fread(f,[data.nx data.ny],',pb.pre,');'];
          disp(readdata)
      else
          eval(['data.',data.field,' = zeros(data.nx,data.ny,nt);']);
          readdata = ['data.',data.field,'(:,:,n) = fread(f,[data.nx data.ny],',pb.pre,');'];
      end
      
  end

  disp(['loading ',num2str(nt),' time steps'])

  switch dim
    case 2
      if data.field=='F'
          for n=1:nt
              for l=1:nF
                  eval(readdata) 
              end
          end
      else
          for n=1:nt
              eval(readdata) 
          end
      end
    otherwise
      eval(readdata) 
  end
  
  fclose(f);
  
  % only return field array for coordinates
  
  switch data.field
   case {'x','y','xq','xr','yq','yr','J',...
	'rho','cs','cp','G','M','gamma','nu'}
    eval(['data = data.',data.field,';'])
  end